/* File:       $Id: JobInfoTestImpl.java 2482 2012-08-24 13:18:17Z svc $
 * Revision:   $Revision: 2482 $
 * Author:     $Author: svc $
 * Date:       $Date: 2012-08-24 15:18:17 +0200 (Fri, 24 Aug 2012) $
 *
 * The Netarchive Suite - Software to harvest and preserve websites
 * Copyright 2004-2012 The Royal Danish Library, the Danish State and
 * University Library, the National Library of France and the Austrian
 * National Library.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package dk.netarkivet.harvester.harvesting;

/**
 * Test implementation of JobInfo used mostly by HeritrixFiles unittests. 
 *
 */
public class JobInfoTestImpl implements JobInfo {

    private Long jobId;
    private Long harvestId;

    public JobInfoTestImpl(Long jobId, Long harvestId) {
        this.jobId = jobId;
        this.harvestId = harvestId;
    }
    
    @Override
    public Long getJobID() {
        return jobId;
    }

    @Override
    public Long getOrigHarvestDefinitionID() {
        return this.harvestId;
    }

    @Override
    public String getHarvestFilenamePrefix() {
        return jobId + "-" + harvestId;
    }
    
}
